%define		nspr_version	4.8.6
%define		nss_version	3.12.7
%define		cairo_version	1.10.0
%define		int_version 1.9.2
%define		version_internal 1.9.2
#define		beta 
#define		relc 1

Distribution:	CCux
Packager:  	Christian Wasem <wasem@ccux-linux.de>

Summary:        XUL Runtime for Gecko Applications
Name:           xulrunner
Version:        1.9.2.9
Release:        1
BuildArch:	i686
URL:            http://www.mozilla.org/projects/xulrunner/
License:        MPLv1.1 or GPLv2+ or LGPLv2+
Group:          Internet
Source0:        xulrunner-%{version}%{?beta:b%{beta}}%{?relc:rc%{relc}}.source.tar.bz2
Source200:      %{name}-mozconfig
Source201:      %{name}-ccux-default-prefs.js
Source202:      %{name}.1
Source203:      find-external-requires

# build patches
Patch0:         xulrunner-version.patch
Patch1:         mozilla-build.patch
Patch2:         mozilla-192-path.patch
Patch3:         mozilla-jemalloc.patch
Patch4:         mozilla-about-firefox-version.patch
Patch7:         xulrunner-1.9.2.1-build.patch
Patch8:         mozilla-plugin.patch
Patch10:        mozilla-192-pkgconfig.patch
Patch100:       mozilla-ps-pdf-simplify-operators.patch
Patch101:	xulrunner-libpng14.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}
BuildArch:	i686

#Manually build requires
BuildRequires:  nspr-devel >= %{nspr_version}
BuildRequires:  nss-devel >= %{nss_version}
BuildRequires:  cairo-devel >= %{cairo_version}
BuildRequires:  libpng-devel
BuildRequires:  libgnomeui-devel
BuildRequires:  krb5-devel
BuildRequires:  curl-devel
BuildRequires: libxcb-devel
BuildRequires: xcb-util-devel
BuildRequires:  gobject-introspection-devel
BuildRequires:  pkg-config
BuildRequires:  libXxf86vm-devel
BuildRequires:  libXdamage-devel
BuildRequires:  libffi-devel

#Automatically resolved build dependencies
BuildRequires: atk-devel
BuildRequires: bzip2-devel
BuildRequires: cairo-devel
BuildRequires: dbus-devel
BuildRequires: dbus-glib-devel
#BuildRequires: firefox
BuildRequires: fontconfig-devel
BuildRequires: freetype-devel
BuildRequires: GConf-devel
BuildRequires: glibc-devel
BuildRequires: glib-devel
BuildRequires: gnome-vfs-devel
BuildRequires: gtk2+-devel >= 2.21.6
BuildRequires: gtk2+
BuildRequires: hunspell-devel
BuildRequires: lcms-devel
BuildRequires: libbonobo-devel
BuildRequires: libgcc
BuildRequires: libgnome-devel
BuildRequires: libIDL-devel
BuildRequires: libjpeg-devel
BuildRequires: libstdc++-devel
BuildRequires: libX11-devel
BuildRequires: libXft-devel
BuildRequires: libXrender-devel
BuildRequires: libXt-devel
BuildRequires: nspr-devel
BuildRequires: nss-devel
BuildRequires: ORBit2-devel
BuildRequires: pango-devel
BuildRequires: popt-devel
BuildRequires: sqlite-devel
BuildRequires: zlib-devel

BuildRequires: wireless-tools-devel
BuildRequires: libnotify-devel

Requires:       nspr >= %{nspr_version}
Requires:       nss >= %{nss_version}
Provides:       gecko-libs = %{version}

# GRE stuff
%ifarch x86_64 ia64 ppc64 s390x
%define gre_conf_file gre64.conf
%else
%define gre_conf_file gre.conf
%endif

# Library path
%ifarch x86_64 ia64 ppc64 s390x
%define ld_conf_file xulrunner-64.conf
%else
%define ld_conf_file xulrunner-32.conf
%endif

%description
XULRunner provides the XUL Runtime environment for Gecko applications.

%package	devel
Summary:	Development files for Gecko
Group:		Development/Libraries
Requires:	xulrunner = %{version}-%{release}
Requires:	nspr-devel >= %{nspr_version}
Requires:	nss-devel >= %{nss_version}
Provides:	gecko-devel = %{version}

Obsoletes:	mozilla-devel
Obsoletes:	firefox-devel < 2.1

%description	devel
Gecko development files.

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%preun
# is it a final removal?
if [ $1 -eq 0 ]; then
  %{__rm} -rf ${MOZ_APP_DIR}/components
fi

%prep
dir /usr/include/gtk-2.0/gtk/gtk.h
%setup -q -c
cd mozilla-%{int_version}

sed -e 's/__RPM_VERSION_INTERNAL__/%{version_internal}/' %{P:%%PATCH0} \
    > version.patch
%{__patch} -p1 -b --suffix .version --fuzz=0 < version.patch

%patch1  -p1 -b .build
%patch2  -p1 -b .path
%patch3  -p1 -b .jemalloc
%patch4  -p1 
%patch7 -p2
%patch8 -p1

%patch10 -p1 -b .pk

%patch100 -p1 -b .ps-pdf-simplify-operators
%patch101 -p1

%{__rm} -f .mozconfig
%{__cp} %{SOURCE200} .mozconfig

%build
cd mozilla-%{int_version}

INTERNAL_GECKO=%{version_internal}
MOZ_APP_DIR=%{_libdir}/%{name}-${INTERNAL_GECKO}

# Mozilla builds with -Wall with exception of a few warnings which show up
# everywhere in the code; so, don't override that.
MOZ_OPT_FLAGS=$(echo $RPM_OPT_FLAGS | %{__sed} -e 's/-Wall//')
export CFLAGS=$MOZ_OPT_FLAGS
export CXXFLAGS=$MOZ_OPT_FLAGS

export PREFIX='%{_prefix}'
export LIBDIR='%{_libdir}'

MOZ_SMP_FLAGS=-j1
#[ -z "$RPM_BUILD_NCPUS" ] && \
#     RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"
#[ "$RPM_BUILD_NCPUS" -gt 1 ] && MOZ_SMP_FLAGS=-j2

export LDFLAGS="-Wl,-rpath,${MOZ_APP_DIR}"
make -f client.mk build STRIP="/bin/true" MOZ_MAKE_FLAGS="$MOZ_SMP_FLAGS" PYTHON="/usr/bin/python2.6"

%install
cd mozilla-%{int_version}
%{__rm} -rf $RPM_BUILD_ROOT

INTERNAL_GECKO=%{version_internal}

INTERNAL_APP_NAME=%{name}-${INTERNAL_GECKO}
MOZ_APP_DIR=%{_libdir}/${INTERNAL_APP_NAME}

INTERNAL_APP_SDK_NAME=%{name}-sdk-${INTERNAL_GECKO}
MOZ_APP_SDK_DIR=%{_libdir}/${INTERNAL_APP_SDK_NAME}

DESTDIR=$RPM_BUILD_ROOT make install

%{__mkdir_p} $RPM_BUILD_ROOT/${MOZ_APP_DIR} \
             $RPM_BUILD_ROOT%{_datadir}/idl/${INTERNAL_APP_SDK_NAME} \
             $RPM_BUILD_ROOT%{_includedir}/${INTERNAL_APP_SDK_NAME}

%{__install} -p dist/sdk/bin/regxpcom $RPM_BUILD_ROOT/$MOZ_APP_DIR

%{__mkdir_p} $RPM_BUILD_ROOT{%{_libdir},%{_bindir},%{_datadir}/applications}

# set up our default preferences
%{__cat} %{SOURCE201} | %{__sed} -e 's,RPM_VERREL,%{version}-%{release},g' > cc-default-prefs
%{__install} -p -D -m 644 cc-default-prefs $RPM_BUILD_ROOT/${MOZ_APP_DIR}/defaults/pref/all-ccux.js
%{__rm} cc-default-prefs

%{__install} -p -D -m 644 %{SOURCE202} $RPM_BUILD_ROOT%{_mandir}/man1/%{name}.1

%{__rm} -f $RPM_BUILD_ROOT${MOZ_APP_DIR}/%{name}-config

cd $RPM_BUILD_ROOT${MOZ_APP_DIR}/chrome
find . -name "*" -type d -maxdepth 1 -exec %{__rm} -rf {} \;
cd -

# system extensions and plugins support
%{__mkdir_p} $RPM_BUILD_ROOT%{_datadir}/mozilla/extensions
%{__mkdir_p} $RPM_BUILD_ROOT%{_libdir}/mozilla/extensions
%{__mkdir_p} $RPM_BUILD_ROOT%{_libdir}/mozilla/plugins
%{__mkdir_p} $RPM_BUILD_ROOT%{_sysconfdir}/skel/.mozilla/extensions
%{__mkdir_p} $RPM_BUILD_ROOT%{_sysconfdir}/skel/.mozilla/plugins

# Prepare our devel package
%{__mkdir_p} $RPM_BUILD_ROOT/%{_includedir}/${INTERNAL_APP_SDK_NAME}
%{__mkdir_p} $RPM_BUILD_ROOT/%{_datadir}/idl/${INTERNAL_APP_SDK_NAME}
%{__mkdir_p} $RPM_BUILD_ROOT/%{_libdir}/pkgconfig

%{__cp} -rL dist/include/* \
  $RPM_BUILD_ROOT/%{_includedir}/${INTERNAL_APP_SDK_NAME}

# Copy pc files (for compatibility with 1.9.1)
%{__cp} $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/libxul.pc \
        $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/libxul-unstable.pc
%{__cp} $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/libxul-embedding.pc \
        $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/libxul-embedding-unstable.pc

# Copy mozilla-config to stable include dir
%{__cp} dist/include/mozilla-config.h \
  $RPM_BUILD_ROOT/%{_includedir}/${INTERNAL_APP_SDK_NAME}/stable


install -c -m 755 dist/bin/xpcshell \
  dist/bin/xpidl \
  dist/bin/xpt_dump \
  dist/bin/xpt_link \
  $RPM_BUILD_ROOT/${MOZ_APP_DIR}

%{__rm} -rf $RPM_BUILD_ROOT/%{_includedir}/${INTERNAL_APP_NAME}
%{__rm} -rf $RPM_BUILD_ROOT/%{_datadir}/idl/${INTERNAL_APP_NAME}

%{__rm} -rf $RPM_BUILD_ROOT${MOZ_APP_SDK_DIR}/include
ln -s  %{_includedir}/${INTERNAL_APP_SDK_NAME} \
       $RPM_BUILD_ROOT${MOZ_APP_SDK_DIR}/include

%{__rm} -rf $RPM_BUILD_ROOT${MOZ_APP_SDK_DIR}/idl
ln -s  %{_datadir}/idl/${INTERNAL_APP_SDK_NAME} \
       $RPM_BUILD_ROOT${MOZ_APP_SDK_DIR}/idl

%{__rm} -rf $RPM_BUILD_ROOT${MOZ_APP_SDK_DIR}/sdk/include
ln -s  %{_includedir}/${INTERNAL_APP_SDK_NAME} \
       $RPM_BUILD_ROOT${MOZ_APP_SDK_DIR}/sdk/include

%{__rm} -rf $RPM_BUILD_ROOT${MOZ_APP_SDK_DIR}/sdk/idl
ln -s  %{_datadir}/idl/${INTERNAL_APP_SDK_NAME} \
       $RPM_BUILD_ROOT${MOZ_APP_SDK_DIR}/sdk/idl

find $RPM_BUILD_ROOT/%{_includedir} -type f -name "*.h" | xargs chmod 644
find $RPM_BUILD_ROOT/%{_datadir}/idl -type f -name "*.idl" | xargs chmod 644

%{__rm} -rf $RPM_BUILD_ROOT${MOZ_APP_SDK_DIR}/sdk/lib/*.so
pushd $RPM_BUILD_ROOT${MOZ_APP_DIR}
for i in *.so; do
    ln -s ${MOZ_APP_DIR}/$i $RPM_BUILD_ROOT${MOZ_APP_SDK_DIR}/sdk/lib/$i
done
popd

# GRE Stuff
MOZILLA_GECKO_VERSION=`./config/milestone.pl --topsrcdir=.`
%{__mv} $RPM_BUILD_ROOT/etc/gre.d/$MOZILLA_GECKO_VERSION".system.conf" \
        $RPM_BUILD_ROOT/etc/gre.d/%{gre_conf_file}
chmod 644 $RPM_BUILD_ROOT/etc/gre.d/%{gre_conf_file}


%{__mkdir_p} $RPM_BUILD_ROOT/etc/ld.so.conf.d
%{__cat} > $RPM_BUILD_ROOT/etc/ld.so.conf.d/%{ld_conf_file} << EOF
${MOZ_APP_DIR}
EOF
                        
# Copy over the LICENSE
install -c -m 644 LICENSE $RPM_BUILD_ROOT${MOZ_APP_DIR}

# Use the system hunspell dictionaries
%{__rm} -rf ${RPM_BUILD_ROOT}${MOZ_APP_DIR}/dictionaries
ln -s %{_datadir}/myspell ${RPM_BUILD_ROOT}${MOZ_APP_DIR}/dictionaries

# ghost files
%{__mkdir_p} $RPM_BUILD_ROOT${MOZ_APP_DIR}/components
touch $RPM_BUILD_ROOT${MOZ_APP_DIR}/components/compreg.dat
touch $RPM_BUILD_ROOT${MOZ_APP_DIR}/components/xpti.dat
%{__mkdir_p} $RPM_BUILD_ROOT${MOZ_APP_DIR}/extensions

%files
%defattr(-,root,root,-)
%{_bindir}/xulrunner
%{_mandir}/man1/*
%{_libdir}/mozilla
%{_datadir}/mozilla
%dir /etc/gre.d
/etc/gre.d/%{gre_conf_file}
%dir %{_libdir}/%{name}-%{version_internal}
%{_libdir}/%{name}-%{version_internal}/LICENSE
%{_libdir}/%{name}-%{version_internal}/README.txt
%{_libdir}/%{name}-%{version_internal}/chrome
%{_libdir}/%{name}-%{version_internal}/dictionaries
%ghost %{_libdir}/%{name}-%{version_internal}/components/compreg.dat
%ghost %{_libdir}/%{name}-%{version_internal}/components/xpti.dat
%{_libdir}/%{name}-%{version_internal}/components
%{_libdir}/%{name}-%{version_internal}/defaults
%{_libdir}/%{name}-%{version_internal}/extensions
%{_libdir}/%{name}-%{version_internal}/greprefs
%{_libdir}/%{name}-%{version_internal}/icons
%{_libdir}/%{name}-%{version_internal}/modules
%{_libdir}/%{name}-%{version_internal}/plugins
%{_libdir}/%{name}-%{version_internal}/res
%{_libdir}/%{name}-%{version_internal}/libmozjs.so
%{_libdir}/%{name}-%{version_internal}/libxpcom.so
%{_libdir}/%{name}-%{version_internal}/libxul.so
%{_libdir}/%{name}-%{version_internal}/mozilla-xremote-client
%{_libdir}/%{name}-%{version_internal}/run-mozilla.sh
%{_libdir}/%{name}-%{version_internal}/regxpcom
%{_libdir}/%{name}-%{version_internal}/xulrunner
%{_libdir}/%{name}-%{version_internal}/xulrunner-bin
%{_libdir}/%{name}-%{version_internal}/xulrunner-stub
%{_libdir}/%{name}-%{version_internal}/platform.ini
%{_libdir}/%{name}-%{version_internal}/dependentlibs.list
%{_libdir}/%{name}-%{version_internal}/plugin-container
%{_sysconfdir}/ld.so.conf.d/xulrunner-32.conf
%{_sysconfdir}/skel/.mozilla
# XXX See if these are needed still
%exclude %{_libdir}/%{name}-%{version_internal}/update.locale
%exclude %{_libdir}/%{name}-%{version_internal}/updater

%files devel
%defattr(-,root,root)
%{_datadir}/idl/%{name}-sdk-%{version_internal}
#%{_includedir}/%{name}-%{version_internal}
%{_includedir}/%{name}-sdk-%{version_internal}
%{_libdir}/%{name}-sdk-%{version_internal}
%{_libdir}/%{name}-%{version_internal}/xpcshell
%{_libdir}/%{name}-%{version_internal}/xpidl
%{_libdir}/%{name}-%{version_internal}/xpt_dump
%{_libdir}/%{name}-%{version_internal}/xpt_link
%{_pkgconfig}/libxul-embedding.pc
%{_pkgconfig}/libxul.pc
%{_pkgconfig}/libxul-embedding-unstable.pc
%{_pkgconfig}/libxul-unstable.pc
%{_pkgconfig}/mozilla-gtkmozembed-embedding.pc
%{_pkgconfig}/mozilla-gtkmozembed.pc
%{_pkgconfig}/mozilla-js.pc
%{_pkgconfig}/mozilla-plugin.pc


%clean
%{__rm} -rf $RPM_BUILD_ROOT

%changelog
* Mon Sep 20 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.9.2.9-1
- Version update
* Sat Aug 28 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.9.2.8-2
- rebuilt against libpng 1.4.3
* Sun Aug 01 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.9.2.8-1
- Version update
* Tue Jul 20 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.9.2.6-1
- Version update
* Tue Feb 16 2010 Christian Metzen <metzench@ccux-linux.de> 1.9.2.1-2
- readd devel-unstable files for compat to 1.9.1
* Tue Jan 26 2010 Christian Metzen <metzench@ccux-linux.de> 1.9.2.1-1
- Version update to final release
- should fix ff3.6 issues
* Thu Jan 14 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.9.2-2
- reconfigured to fix stability issue with Javascript
* Thu Jan 14 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.9.2-2
- Version update
- rc 1
* Thu Nov 12 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.9.2-1
- Version update
- beta 1
* Fri Nov 06 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.9.1.4-1
- Version update
* Tue Oct 06 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.9.1.3-1
- Version update
* Tue Aug 04 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.9.1-4
- source from firefox 3.5.2
- switched to cairo-qt4 backend
* Sun Jul 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.9.1-3
- version update 1.9.1
- built against libjpeg 7
* Sat Jun 20 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.9.1-2
- rc2
* Thu May 28 2009 Christian Metzen <metzench@ccux-linux.de> 1.9.1-1
- Version update
- beta 4
* Thu Mar 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.9.0.7-1
- Version update
* Wed Feb 25 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.9.0.6-1
- Version update
- temporarily disabled system-hunspell support
* Sun Jan 11 2009 Christian Metzen <metzench@ccux-linux.de> 1.9.0.5-1
- Version update
- updated pkgconfig patch to include nspr, neccessary for some packages
* Mon Dec 22 2008 Christian Wasem <wasem@ccux-linux.de> 1.9.0.4-1
- Version update
* Thu Sep 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.9.0.2-3
- workaround for FS BUG #28 : add extensions dir
* Sun Aug 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.9.0.1-2
- removed pre suffix (FS BUG #28)
- added openldap support (needed for Openoffice)
* Sat Aug 09 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.9.0.1-1
- version update
* Thu Jun 19 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.9-5
- final version
* Sun Jun 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.9-4
- cvs 20080604 / 1.9rc2
* Sat May 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.9-3
- cvs 20080516 for firefox 3.0 rc1
* Sat Apr 12 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.9-2
- rebuilt against hunspell 1.2.2b
* Wed Apr 02 2008 Christian Wasem <wasem@ccux-linux.de> 1.9-1
- Initial release
